-- IMPORTS
require('opts')
require('plug')
require('keys')
require('autocmd')

-- PLUGINS
require('ayu').setup({ mirage = true })
require('ayu').colorscheme()
require('lualine').setup { options = { theme = 'ayu_mirage' }, }
require('nvim-tree').setup()
require('colorizer').setup()
require('nvim_comment').setup()
require("nvim-autopairs").setup()

-- -- AUTOCOMPLETE
--   -- https://github.com/neovim/nvim-lspconfig/blob/master/doc/server_configurations.md
lspconfig = require'lspconfig'
lspconfig.pylsp.setup{}           -- Python
-- lspconfig.tsserver.setup{}        -- Typescript
-- lspconfig.rust_analyzer.setup{}   -- Rust
-- lspconfig.html.setup{}            -- HTML
-- lspconfig.ruby_ls.setup{}         -- Ruby
local capabilities = vim.lsp.protocol.make_client_capabilities()
capabilities = require('cmp_nvim_lsp').default_capabilities(capabilities)
local lsp = require('lspconfig')
lsp.clangd.setup{
    on_attach=lsp_keybindings,
    capabilities = capabilites,   
}
lsp.ccls.setup{
    on_attach=lsp_keybindings,
    capabilities = capabilities,
}

-- LUASNIP
local luasnip = require 'luasnip'

-- NVIM-CMP
local cmp = require 'cmp'
cmp.setup {
  snippet = {
    expand = function(args)
      luasnip.lsp_expand(args.body)
    end,
  },
  mapping = cmp.mapping.preset.insert({
    ['<C-d>'] = cmp.mapping.scroll_docs(-4),
    ['<C-f>'] = cmp.mapping.scroll_docs(4),
    ['<C-Space>'] = cmp.mapping.complete(),
    ['<CR>'] = cmp.mapping.confirm {
      behavior = cmp.ConfirmBehavior.Replace,
      select = true,
    },
    ['<Tab>'] = cmp.mapping(function(fallback)
      if cmp.visible() then
        cmp.select_next_item()
      elseif luasnip.expand_or_jumpable() then
        luasnip.expand_or_jump()
      else
        fallback()
      end
    end, {'i','s'}),
    ['<S-Tab>'] = cmp.mapping(function(fallback)
      if cmp.visible() then
        cmp.select_prev_item()
      elseif luasnip.jumpable(-1) then
        luasnip.jump(-1)
      else
        fallback()
      end
    end, {'i','s'}),
  }),
  sources = {
    {name = 'nvim_lsp'},
    {name = 'luasnip'},
  },
}
